#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <algorithm>


#include <any>
#include <functional>

using namespace std;

struct CountFun {
    CountFun() : counter_(0) {}
    template<typename T> void inc(const any& a) {
		if(a.type() == typeid(T) )
			++counter_;
    }
    int counter_;
};

void zad1(){
    vector<any> v;
    v.push_back(1);
    v.push_back(2.54);
    v.push_back(string("Ala"));
    v.push_back(1.01);
    CountFun counter;
    for_each(v.begin(), v.end(), [&](any a){ counter.inc<double>(a); } );
    cout << counter.counter_ << endl;
}
void fxx(int& count, const string& s, int offset) {
    count += s.size() + offset;
}

void zad2() {
    using PF = std::function<void (int)>;
    int x = 0;
    vector<PF> vpf;
    vpf.push_back([&](int i){fxx(x, string("A"), i);});
	vpf.push_back([&](int i){fxx(x, string("AA"), i);});
	vpf.push_back([&](int i){fxx(x, string("AAA"), i);});
    for_each( vpf.begin(), vpf.end(), [](PF& pf){pf(1);});
    cout << x << endl;
}


int main() {
    zad1();
    zad2();
    return 0;
}
